<head>
    <h2 style="background-color: #495150; color: #FFFFFF; margin-bottom: -10px; font-family: Arial">ACD HMI Demo</h2>
    <hr size="5" style="background-color: #ef7d00; color: #ef7d00">
</head>
<body>
    <label style="font-family: Arial">Status: </label>
    <label id="status" style="background-color:#d51130; color: #FFFFFF; font-family: Arial" >Disconnected</label>
    <br>
    <br>
    <button id="bindHMI" type="button" disabled="true" style="background-color: #d2d4d5; color: #000000; font-family: Arial">Bind HMI</button>
    <button id="unbindHMI" type="button" disabled="true" style="background-color: #d2d4d5; color: #000000; font-family: Arial">Unbind HMI</button>
    <br>
    <br>
    <button id="subscribeBtns" type="button" disabled="true" style="background-color: #d2d4d5; color: #000000; font-family: Arial">Subscribe to button status</button>
    <br>
    <br>
    <label style="font-family: Arial">Emergency switch: </label>
    <label id="statusEmrgncy" style="background-color:#000000; color: #FFFFFF; font-family: Arial" >?</label>
    <br>
    <label style="font-family: Arial">Enable button: </label>
    <label id="statusEnable" style="background-color:#000000; color: #FFFFFF; font-family: Arial" >?</label>
    <br>
    <br>
    <label id="txtOutput" style="font-family: Arial"></label>
    <script language="javascript" type="text/javascript">

        const wsUri = "ws://127.0.0.1:56665/";

        var websocket;
        var subscribedToButtons = false;

        // UI variables
        var btnBindHMI;
        var btnUnbindHMI;
        var btnSubscribe;
        var txtOutput;
        var txtStatus;
        var txtEnable;
        var txtEmergency;

        // initialize the WebSocket connection to the WebAppService and setup the click listeners for the buttons 
        function init() {

            btnBindHMI = document.getElementById("bindHMI");
            btnUnbindHMI = document.getElementById("unbindHMI");
            btnSubscribe = document.getElementById("subscribeBtns");
            txtOutput = document.getElementById("txtOutput");
            txtStatus = document.getElementById("status");
            txtEnable = document.getElementById("statusEnable");
            txtEmergency = document.getElementById("statusEmrgncy");


            writeToScreen("Error log:");
            startWebSocket();

            btnBindHMI.onclick = function() {
                // send the bindHMI command to the WebAppService
                websocket.send("HMI.bindHMI");
            };

            btnUnbindHMI.onclick = function() {
                // send the unbindHMI command to the WebAppService
                websocket.send("HMI.unbindHMI");
            };

            btnSubscribe.onclick = function() {

                if (!subscribedToButtons) {
                    // define the parameters for the command
                    const parameters = {
                        arg1: 1
                    };

                    // send the subscribeToButtonStatus command with the parameters to the WebAppService
                    websocket.send("HMI.subscribeToButtonStatus." + JSON.stringify(parameters));
                }
                else {
                    // define the parameters for the command
                    const parameters = {
                        arg1: 0
                    };

                    txtEnable.textContent = "?";
                    txtEnable.style = "background-color: #000000; color: #FFFFFF; font-family: Arial";

                    txtEmergency.textContent = "?";
                    txtEmergency.style = "background-color: #000000; color: #FFFFFF; font-family: Arial";

                    // send the subscribeToButtonStatus command with the parameters to the WebAppService
                    websocket.send("HMI.subscribeToButtonStatus." + JSON.stringify(parameters));

                    btnSubscribe.textContent = "Subscribe to button status";
                    subscribedToButtons = false
                }
            };
        }

        // start the web socket connetion and react to incoming data
        function startWebSocket() {
            websocket = new WebSocket(wsUri);

            websocket.onopen = function(evt) {
                // enable the bindHMI button as soon as a connection to the web socket is established
                setButtonEnabled("bindHMI", true);
                txtStatus.textContent = "HMI not bound";
                txtStatus.style = "background-color:#d51130; color: #FFFFFF; font-family: Arial";
            };

            websocket.onclose = function(evt) {
                // disable all buttons when the connection is closed
                setButtonEnabled("bindHMI", false);
                setButtonEnabled("unbindHMI", false);
                setButtonEnabled("subscribeBtns", false);
            };

            websocket.onmessage = function(evt) {

                // parse received data sent by the WebAppService
                var message = evt.data;

                var hardwareComponent = message.split('.', 2)[0];
                var command = message.split('.', 2)[1];
                var rawdata = '';

                // separate the data using the substring function
                var dataStartPoint = hardwareComponent.length + command.length + 2;
                if (dataStartPoint < message.length) {
                    rawdata = message.substring(dataStartPoint, message.length);
                }

                try {
                    var data = JSON.parse(rawdata);
                    // hand the parsed data to the interpret data function 
                    interpretData(hardwareComponent, command, data);
                }
                catch (error) {
                    writeToScreen("failed to parse data: " + error);
                }
            };

            websocket.onerror = function(evt) {
                writeToScreen("Communication Error: " + event.message);
            };
        }

        function interpretData(hardwareComponent, command, data) {

            // since we only interpret HMI data, we can pre-filter it here
            if (hardwareComponent == "HMI") {
                if(!("error" in data)) {

                    // decide what to do on what command
                    switch(command) {
                        case "bindHMI":
                            // read the bound parameter if it exists
                            if ("bound" in data) {
                                if(data.bound) {
                                    setButtonEnabled("bindHMI", false);
                                    setButtonEnabled("unbindHMI", true);
                                    setButtonEnabled("subscribeBtns", true);
                                    txtStatus.textContent = "Connected";
                                    txtStatus.style = "background-color:#76b72a; color: #FFFFFF; font-family: Arial";
                                }
                                else {
                                    writeToScreen("Error: failed to bind")
                                }
                            }
                            break;


                        case "buttonStatus":
                            subscribedToButtons = true;
                            btnSubscribe.textContent = "Unsubscribe from button status";

                            // read the enable button parameter if it exists
                            if ("In-EB" in data) {
                                // because there is a '-' char in the parameter name, we cannot read it with data.In-EB, instead we have to use data["In-EB"]
                                if(data["In-EB"]) {
                                    txtEnable.textContent = "pressed";
                                    txtEnable.style = "background-color: #fff700; color: #FFFFFF; font-family: Arial";
                                }
                                else {
                                    txtEnable.textContent = "not pressed";
                                    txtEnable.style = "background-color: #FFFFFF; color: #000000; font-family: Arial";
                                }
                            }

                            // read the emergency switch parameter if it exists
                            if ("In-ES" in data) {
                                if(!data["In-ES"]) {
                                    txtEmergency.textContent = "pressed";
                                    txtEmergency.style = "background-color: #d51130; color: #FFFFFF; font-family: Arial";
                                }
                                else {
                                    txtEmergency.textContent = "not pressed";
                                    txtEmergency.style = "background-color: #FFFFFF; color: #000000; font-family: Arial"
                                }
                            }
                            break;

                        case "unbindHMI":
                            // read the bound parameter if it exists
                            if ("bound" in data) {
                                if(!data.bound) {
                                    setButtonEnabled("bindHMI", true);
                                    setButtonEnabled("unbindHMI", false);
                                    setButtonEnabled("subscribeBtns", false);
                                    txtStatus.textContent = "HMI not bound";
                                    txtStatus.style = "background-color:#d51130; color: #FFFFFF; font-family: Arial";
                                }
                                else {
                                    writeToScreen("Error: failed to unbind");
                                }
                            }
                            break;
                    }
                }
                else {
                    // if there is an error parameter, it will log it to the screen here
                    writeToScreen("Error in command " + command +": " + data.error);
                }
            }
        }

        // append a string to the txtOutput text field
        function writeToScreen(message) {
            var pre = document.createElement("p");
            pre.style.wordWrap = "break-word";
            pre.innerHTML = message;
            txtOutput.appendChild(pre);
        }

        function setButtonEnabled(buttonID, enabled) {
            if (enabled) {
                document.getElementById(buttonID).disabled = false;
                document.getElementById(buttonID).style = "background-color: #76b72a; color: #ffffff";
            }
            else {
                document.getElementById(buttonID).disabled = true;
                document.getElementById(buttonID).style = "background-color: #d2d4d5; color: #000000";
            }
        }

        // call the init function as soon as the window is loaded
        window.addEventListener("load", init, false);
        
    </script>
</body>